<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\api\lists;


use app\common\model\goods\Goods;
use app\common\lists\ListsSearchInterface;
use app\common\model\goods_category\GoodsCategory;
use app\common\service\FileService;


/**
 * Goods列表
 * Class GoodsLists
 * @package app\adminapi\listsgoods
 */
class GoodsLists  extends BaseApiDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/07/07 18:37
     */
    public function setSearch(): array
    {
        return [
            '=' => ['goods_status'],
            '%like%' => ['goods_name','goods_brand'],
            'between' => ['service_total', 'service_fee'],
        ];
    }

    public function queryWhere()
    {
        $where = [];
        $where['user_id'] = 0;//常规商品
        $where['is_agent'] = 0;//常规商品
        if (!empty($this->params['goods_category_id'])) {
            $goodsCategoryId = end($this->params['goods_category_id']);
            $goodsCategoryData = GoodsCategory::where(['status'=>1])->order(['pid' => 'asc','weigh' => 'desc', 'id' => 'desc'])
                ->select()->toArray();
            $ids =get_tree_ids($goodsCategoryData,$goodsCategoryId);
            $ids[] = $goodsCategoryId;
            $where[] = ['goods_category_id','in' ,$ids];
        }
        return $where;
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/07/07 18:37
     */
    public function lists(): array
    {
        $lists = Goods::order(['id' => 'desc'])
            ->where($this->searchWhere)
            ->where($this->queryWhere())
            ->visible(['id','goods_name','goods_image'])
            ->limit($this->limitOffset, $this->limitLength)
            ->select()
            ->toArray();
        return $lists;
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/07/07 18:37
     */
    public function count(): int
    {
        return Goods::where($this->searchWhere)->where($this->queryWhere())->count();
    }

}